//	Copyright 2011 PaletteSoft LLC

// ===========================================================================
// =	CL^															 =
// ===========================================================================
//	002 2011.??.??
//	E
// ---------------------------------------------------------------------------
//	001 2011.02.01				01.00	0000
//	EVK쐬i16F1823 vs 16F628Aj
// ===========================================================================

/*
	{IȃRpCʂmF܂B]Ώۂ̃foCX́A
	EPIC16F1823	2K(ROM)-128(RAM)-256(EEP)
	EPIC16F628A	2K(ROM)-224(RAM)-128(EEP)
	̂QłBMPLAB IDẼj[ConfigureSelectDeviceŐ؂ւ܂B
*/

//	***************************************************************************
//	*	CN[h														  *
//	***************************************************************************

#include	<htc.h>														//	foCXŗL̎擾	 pic.hłǁAŋ߂͂}Cu[
#include	<string.h>													//	񑀍nCu

//	***************************************************************************
//	*	^錾																  *
//	***************************************************************************

typedef			 unsigned char	UB;
typedef			 unsigned short	UH;
typedef			 unsigned long	UW;

typedef	volatile unsigned char	_UB;
typedef	volatile unsigned short	_UH;
typedef	volatile unsigned long	_UW;

//	***************************************************************************
//	*	ϐ																  *
//	***************************************************************************

	//	***** ʏ *****

UB	vValUB1, vValUB2;
UH	vValUH1, vValUH2;
UW	vValUW1, vValUW2;

	//	***** volatile *****

_UB	vVal_UB1, vVal_UB2;
_UH	vVal_UH1, vVal_UH2;
_UW	vVal_UW1, vVal_UW2;

	//	***** ʏ̃|C^ *****

UB	* vPoiUB;
UH	* vPoiUH;
UW	* vPoiUW;

	//	***** volatileȃ|C^ *****

_UB	* vPoi_UB;
_UH	* vPoi_UH;
_UW	* vPoi_UW;

	//	***** ʏ̔z *****

UB	vDimUB[4];
UH	vDimUH[4];
UW	vDimUW[4];

	//	***** volatileȔz *****

_UB	vDim_UB[4];
_UH	vDim_UH[4];
_UW	vDim_UW[4];

//	***************************************************************************
//	*	萔															  *
//	***************************************************************************
void	TestConstValue(void)
{
	//	***** ʏ *****

	vValUB1 = 0;
	vValUB1 = 1;
	vValUB1 = 2;

	vValUH1 = 0;
	vValUH1 = 1;
	vValUH1 = 2;

	vValUW1 = 0;
	vValUW1 = 1;
	vValUW1 = 2;

	//	***** volatile *****

	vVal_UB1 = 0;
	vVal_UB1 = 1;
	vVal_UB1 = 2;

	vVal_UH1 = 0;
	vVal_UH1 = 1;
	vVal_UH1 = 2;

	vVal_UW1 = 0;
	vVal_UW1 = 1;
	vVal_UW1 = 2;
}

//	***************************************************************************
//	*	ϐ															  *
//	***************************************************************************
void	TestValiableValue(void)
{
	//	***** ʏ *****

	vValUB1 = vValUB2;
	vValUH1 = vValUH2;
	vValUW1 = vValUW2;

	//	***** volatileP *****

	vVal_UB1 = vVal_UB2;
	vVal_UH1 = vVal_UH2;
	vVal_UW1 = vVal_UW2;

	//	***** volatileQ *****

	vVal_UB1 = vValUB2;
	vVal_UH1 = vValUH2;
	vVal_UW1 = vValUW2;
}

//	***************************************************************************
//	*	萔i|C^j												  *
//	***************************************************************************
void	TestConstPointer(void)
{
	//	***** |C^̑傫 *****

	vVal_UB1 = sizeof(vPoiUB);
	vVal_UB1 = sizeof(vPoiUH);
	vVal_UB1 = sizeof(vPoiUW);

	//	***** ʏ *****

	vPoiUB = vDimUB;
	vPoiUH = vDimUH;
	vPoiUW = vDimUW;

	//	***** volatile *****

	vPoi_UB = vDim_UB;
	vPoi_UH = vDim_UH;
	vPoi_UW = vDim_UW;
}

//	***************************************************************************
//	*	|C^ANZX													  *
//	***************************************************************************
void	TestAccessPointer(void)
{
	//	***** ʏP *****

	vValUB1 = *vPoiUB;
	vValUH1 = *vPoiUH;
	vValUW1 = *vPoiUW;

	//	***** ʏQ *****

	vVal_UB1 = *vPoiUB;
	vVal_UH1 = *vPoiUH;
	vVal_UW1 = *vPoiUW;

	//	***** volatileP *****

	vValUB1 = *vPoi_UB;
	vValUH1 = *vPoi_UH;
	vValUW1 = *vPoi_UW;

	//	***** volatileQ *****

	vVal_UB1 = *vPoi_UB;
	vVal_UH1 = *vPoi_UH;
	vVal_UW1 = *vPoi_UW;
}

//	***************************************************************************
//	*	|C^Z														  *
//	***************************************************************************
void	TestCalcPointer(void)
{
	//	***** ʏ *****

	vPoiUB ++;
	vPoiUB += 1;
	vPoiUB += 2;
	vPoiUB += vValUB1;

	vPoiUB --;
	vPoiUB -= 1;
	vPoiUB -= 2;
	vPoiUB -= vValUB1;

	vPoiUH ++;
	vPoiUH += 1;
	vPoiUH += 2;
	vPoiUH += vValUB1;

	vPoiUH --;
	vPoiUH -= 1;
	vPoiUH -= 2;
	vPoiUH -= vValUB1;

	vPoiUW ++;
	vPoiUW += 1;
	vPoiUW += 2;
	vPoiUW += vValUB1;

	vPoiUW --;
	vPoiUW -= 1;
	vPoiUW -= 2;
	vPoiUW -= vValUB1;

	//	***** volatile *****

	vPoi_UB ++;
	vPoi_UB += 1;
	vPoi_UB += 2;
	vPoi_UB += vValUB1;

	vPoi_UB --;
	vPoi_UB -= 1;
	vPoi_UB -= 2;
	vPoi_UB -= vValUB1;

	vPoi_UH ++;
	vPoi_UH += 1;
	vPoi_UH += 2;
	vPoi_UH += vValUB1;

	vPoi_UH --;
	vPoi_UH -= 1;
	vPoi_UH -= 2;
	vPoi_UH -= vValUB1;

	vPoi_UW ++;
	vPoi_UW += 1;
	vPoi_UW += 2;
	vPoi_UW += vValUB1;

	vPoi_UW --;
	vPoi_UW -= 1;
	vPoi_UW -= 2;
	vPoi_UW -= vValUB1;
}

//	***************************************************************************
//	*	z																  *
//	***************************************************************************
void	TestDim(void)
{
	//	***** ŒʒuFʏ *****

	vDimUB[0] = 0;
	vDimUB[0] = 1;

	vDimUH[0] = 3;
	vDimUH[1] = 4;

	vDimUW[0] = 6;
	vDimUW[1] = 7;

	//	***** ŒʒuFvolatile *****

	vDim_UB[0] = 0;
	vDim_UB[0] = 1;

	vDim_UH[0] = 3;
	vDim_UH[1] = 4;

	vDim_UW[0] = 6;
	vDim_UW[1] = 7;

	//	***** ŒʒuFϐ *****

	vDimUB[0] = vValUB1;
	vDimUH[1] = vValUH1;
	vDimUW[2] = vValUW1;

	vDim_UB[0] = vValUB1;
	vDim_UH[1] = vValUH1;
	vDim_UW[2] = vValUW1;

	//	***** ψʒu *****

	vDimUB[vValUB1]  = 10;
	vDimUH[vValUB1]  = 13;
	vDimUW[vValUB1]  = 16;

	vDim_UB[vValUB1] = 17;
	vDim_UH[vValUB1] = 18;
	vDim_UW[vValUB1] = 19;
}

//	***************************************************************************
//	*	萔															  *
//	***************************************************************************
void	TestDummy(void)	{		}
void	TestIfConstValue(void)
{
	//	***** ʏ *****

	if (vValUB1 == 0)			{	TestDummy();	}
	if (vValUB1 == 1)			{	TestDummy();	}
	if (vValUB1 == 2)			{	TestDummy();	}

	if (vValUH1 == 0)			{	TestDummy();	}
	if (vValUH1 == 1)			{	TestDummy();	}
	if (vValUH1 == 2)			{	TestDummy();	}

	if (vValUW1 == 0)			{	TestDummy();	}
	if (vValUW1 == 1)			{	TestDummy();	}
	if (vValUW1 == 2)			{	TestDummy();	}


	if (vValUB1 > 0)			{	TestDummy();	}
	if (vValUB1 > 1)			{	TestDummy();	}
	if (vValUB1 > 2)			{	TestDummy();	}

	if (vValUH1 > 0)			{	TestDummy();	}
	if (vValUH1 > 1)			{	TestDummy();	}
	if (vValUH1 > 2)			{	TestDummy();	}

	if (vValUW1 > 0)			{	TestDummy();	}
	if (vValUW1 > 1)			{	TestDummy();	}
	if (vValUW1 > 2)			{	TestDummy();	}

	//	***** volatile *****

	if (vVal_UB1 == 0)			{	TestDummy();	}
	if (vVal_UB1 == 1)			{	TestDummy();	}
	if (vVal_UB1 == 2)			{	TestDummy();	}

	if (vVal_UH1 == 0)			{	TestDummy();	}
	if (vVal_UH1 == 1)			{	TestDummy();	}
	if (vVal_UH1 == 2)			{	TestDummy();	}

	if (vVal_UW1 == 0)			{	TestDummy();	}
	if (vVal_UW1 == 1)			{	TestDummy();	}
	if (vVal_UW1 == 2)			{	TestDummy();	}


	if (vVal_UB1 > 0)			{	TestDummy();	}
	if (vVal_UB1 > 1)			{	TestDummy();	}
	if (vVal_UB1 > 2)			{	TestDummy();	}

	if (vVal_UH1 > 0)			{	TestDummy();	}
	if (vVal_UH1 > 1)			{	TestDummy();	}
	if (vVal_UH1 > 2)			{	TestDummy();	}

	if (vVal_UW1 > 0)			{	TestDummy();	}
	if (vVal_UW1 > 1)			{	TestDummy();	}
	if (vVal_UW1 > 2)			{	TestDummy();	}
}

//	***************************************************************************
//	*	ϐ															  *
//	***************************************************************************
void	TestIfValiableValue(void)
{
	//	***** ʏ *****

	if (vValUB1 == vValUB2)		{	TestDummy();	}
	if (vValUH1 == vValUH2)		{	TestDummy();	}
	if (vValUW1 == vValUW2)		{	TestDummy();	}

	if (vValUB1 > vValUB2)		{	TestDummy();	}
	if (vValUH1 > vValUH2)		{	TestDummy();	}
	if (vValUW1 > vValUW2)		{	TestDummy();	}

	//	***** volatileP *****

	if (vVal_UB1 == vValUB2)	{	TestDummy();	}
	if (vVal_UH1 == vValUH2)	{	TestDummy();	}
	if (vVal_UW1 == vValUW2)	{	TestDummy();	}

	if (vVal_UB1 > vValUB2)		{	TestDummy();	}
	if (vVal_UH1 > vValUH2)		{	TestDummy();	}
	if (vVal_UW1 > vValUW2)		{	TestDummy();	}

	//	***** volatileQ *****

	if (vVal_UB1 == vVal_UB2)	{	TestDummy();	}
	if (vVal_UH1 == vVal_UH2)	{	TestDummy();	}
	if (vVal_UW1 == vVal_UW2)	{	TestDummy();	}

	if (vVal_UB1 > vVal_UB2)	{	TestDummy();	}
	if (vVal_UH1 > vVal_UH2)	{	TestDummy();	}
	if (vVal_UW1 > vVal_UW2)	{	TestDummy();	}
}

//	***************************************************************************
//	*	WX^															  *
//	***************************************************************************
void	TestReg(void)
{
	//	***** PORTA *****

	PORTA = 0;
	PORTA = 1;
	PORTA = 2;
	PORTA = vValUB1;

	RA0 = 0;
	RA0 = 1;

	if (RA0 == 0)		{	TestDummy();	}

	if (RA0 != 0)		{	TestDummy();	}
	if (RA0 == 1)		{	TestDummy();	}

	//	***** TRISA *****

	TRISA = 0;
	TRISA = 1;
	TRISA = 2;
	TRISA = vValUB1;

	TRISA0 = 0;
	TRISA0 = 1;

	if (TRISA0 == 0)	{	TestDummy();	}

	if (TRISA0 != 0)	{	TestDummy();	}
	if (TRISA0 == 1)	{	TestDummy();	}

	//	***** INTCON *****

	INTCON = 0;
	INTCON = 1;
	INTCON = 2;
	INTCON = vValUB1;

	GIE = 0;
	GIE = 1;

	if (GIE == 0)		{	TestDummy();	}

	if (GIE != 0)		{	TestDummy();	}
	if (GIE == 1)		{	TestDummy();	}

	//	*****  *****								oNʃGAւ̃ANZX@i֐ĂԂƁǍ̖߂̓oN؂ւK{̂͂j

	TestDummy();
	PORTA  = 2;		//	Bank0			0 1 C
	TRISA  = 3;		//	Bank1
	INTCON = 4;		//	Common bank

	TestDummy();
	PORTA  = 2;		//	Bank0			0 C 1
	INTCON = 4;		//	Common bank
	TRISA  = 3;		//	Bank1

	TestDummy();
	TRISA  = 3;		//	Bank1			1 0 C
	PORTA  = 2;		//	Bank0
	INTCON = 4;		//	Common bank

	TestDummy();
	TRISA  = 3;		//	Bank1			1 C 0
	INTCON = 4;		//	Common bank
	PORTA  = 2;		//	Bank0

	TestDummy();
	INTCON = 4;		//	Common bank		C 0 1
	PORTA  = 2;		//	Bank0
	TRISA  = 3;		//	Bank1

	TestDummy();
	INTCON = 4;		//	Common bank		C 1 0
	TRISA  = 3;		//	Bank1
	PORTA  = 2;		//	Bank0
}

//	***************************************************************************
//	*	X^bN	16F1823̂ݕ]											  *
//	***************************************************************************
void	TestStack_17(void)	{	;	}
#if 0
void	TestStack_16(void)	{	TestStack_17();	}						//	͑ʖ
#else
void	TestStack_16(void)	{	;	}									//	荞݂ȂΑv
#endif

#if 0
void	TestStack_15(void)	{	TestStack_16();	}						//	荞݂Ƒʖ
#else
void	TestStack_15(void)	{	;	}									//	荞݂Ăv
#endif

void	TestStack_14(void)	{	TestStack_15();	}
void	TestStack_13(void)	{	TestStack_14();	}
void	TestStack_12(void)	{	TestStack_13();	}
void	TestStack_11(void)	{	TestStack_12();	}
void	TestStack_10(void)	{	TestStack_11();	}
void	TestStack_09(void)	{	TestStack_10();	}
void	TestStack_08(void)	{	TestStack_09();	}
void	TestStack_07(void)	{	TestStack_08();	}
void	TestStack_06(void)	{	TestStack_07();	}
void	TestStack_05(void)	{	TestStack_06();	}
void	TestStack_04(void)	{	TestStack_05();	}
void	TestStack_03(void)	{	TestStack_04();	}
void	TestStack_02(void)	{	TestStack_03();	}
void	TestStack(void)
{																		//	܂͂Px
	TestStack_02();
}

//	***************************************************************************
//	*	ubN														  *
//	***************************************************************************
void	TestBlock(void)
{
	memset(vDimUB, 0x00, sizeof(vDimUB));								//	Zbg
	memcpy(vDimUB, vPoiUB, sizeof(vDimUB));								//	Rs[
}

//	***************************************************************************
//	*	C																  *
//	***************************************************************************
int		main(void)
{
	//	*****  *****

	TestConstValue();													//	萔
	TestValiableValue();												//	ϐ

	TestConstPointer();													//	萔i|C^j
	TestAccessPointer();												//	|C^ANZX
	TestCalcPointer();													//	|C^Z

	TestDim();															//	z

	//	*****  *****

	TestIfConstValue();													//	萔
	TestIfValiableValue();												//	ϐ

	//	***** WX^ANZX *****

	TestReg();															//	WX^

	//	***** X^bN *****

#if 1																	//	eʔr͂OɂĂ݂
#if defined(_16F1823)													//	foCX̎i16F1823 vs 16F628Aj
	TestStack();														//	X^bN̐[
#endif
#endif

	//	***** ubN *****

	TestBlock();														//	Rs[tB

	//	***** ܂ *****

	return(0);															//	ʏ͖߂邱Ƃ͂ȂǁA񂾂CI init main(void)ɂĂ݂
}
//	***************************************************************************
//	*	荞															  *
//	***************************************************************************
void	interrupt	ipt(void)
{
	vValUB1 = 1;
}

